Skip to content

JMAP API Reference

Serverless Inbox implements JMAP (RFC 8620) and JMAP for Mail (RFC 8621).

Endpoint: POST /jmap

All requests use a single endpoint. The body is a JSON object containing a using array (capability URIs) and a methodCalls array. Each method call is a 3-tuple [methodName, arguments, clientId].

Supported capabilities:

  • urn:ietf:params:jmap:core
  • urn:ietf:params:jmap:mail
  • urn:ietf:params:jmap:submission
  • urn:ietf:params:jmap:contacts
  • urn:ietf:params:jmap:principals
  • https://specs.serverlessinbox.com/page-token
  • https://specs.serverlessinbox.com/websocket

Method arguments can reference a previous result in the same request by prefixing the argument key with #. For example, pass "#ids": { "resultOf": "r1", "name": "Email/query", "path": "/ids" } to use the ids from an Email/query call with client ID r1.

MethodObject typeVerb
Mailbox/getMailboxget
Mailbox/changesMailboxchanges
Email/getEmailget
Email/changesEmailchanges
Email/queryEmailquery
Email/queryChangesEmailqueryChanges
Email/setEmailset
Thread/getThreadget
Mailbox/setMailboxset
Mailbox/queryMailboxquery
Email/importEmailimport
Email/copyEmailcopy
Email/parseEmailparse
Thread/queryThreadquery
Thread/changesThreadchanges
EmailSubmission/getEmailSubmissionget
EmailSubmission/setEmailSubmissionset
EmailSubmission/queryEmailSubmissionquery
EmailSubmission/queryChangesEmailSubmissionqueryChanges
EmailSubmission/changesEmailSubmissionchanges
Identity/getIdentityget
Identity/setIdentityset
Identity/changesIdentitychanges
Mailbox/queryChangesMailboxqueryChanges
Thread/queryChangesThreadqueryChanges
AddressBook/getAddressBookget
AddressBook/setAddressBookset
AddressBook/queryAddressBookquery
AddressBook/queryChangesAddressBookqueryChanges
AddressBook/changesAddressBookchanges
ContactCard/getContactCardget
ContactCard/setContactCardset
ContactCard/queryContactCardquery
ContactCard/queryChangesContactCardqueryChanges
ContactCard/changesContactCardchanges
ContactCard/copyContactCardcopy
Principal/getPrincipalget
Principal/setPrincipalset
Principal/queryPrincipalquery
Principal/queryChangesPrincipalqueryChanges
Principal/changesPrincipalchanges
ShareNotification/getShareNotificationget
ShareNotification/setShareNotificationset
ShareNotification/queryShareNotificationquery
ShareNotification/queryChangesShareNotificationqueryChanges
ShareNotification/changesShareNotificationchanges